const onButtonClick = (name) => {
DevExpress.ui.notify(`The "${name}" button has been clicked`);
};
const onSelectionChanged = (name) => {
DevExpress.ui.notify(`The "${name}" value has been changed`);
};
const onFontFamilyClick = () => {
DevExpress.ui.notify('The "Font Family" value has been changed');
};
const onHeadingClick = () => {
DevExpress.ui.notify('The "Heading" value has been changed');
};
const toolbarSeparator = {
locateInMenu: 'auto',
location: 'before',
template(itemData, itemIndex, element) {
$('<div>')
.addClass('toolbar-separator')
.appendTo(element);
},
menuItemTemplate(itemData, itemIndex, element) {
$('<div>')
.addClass('toolbar-menu-separator')
.appendTo(element);
},
};
const toolbarItems = [
{
location: 'before',
widget: 'dxButton',
options: {
icon: 'undo',
onClick() {
onButtonClick('Undo');
},
},
},
{
location: 'before',
widget: 'dxButton',
options: {
icon: 'redo',
onClick() {
onButtonClick('Redo');
},
},
},
toolbarSeparator,
{
location: 'before',
locateInMenu: 'auto',
widget: 'dxDropDownButton',
options: {
width: '100%',
displayExpr: 'text',
keyExpr: 'size',
useSelectMode: true,
items: fontSizes,
selectedItemKey: 14,
itemTemplate(itemData) {
return $('<div>')
.text(itemData.text)
.css('font-size', `${itemData.size}px`);
},
onSelectionChanged() {
onSelectionChanged('Font Size');
},
},
},
{
location: 'before',
locateInMenu: 'auto',
widget: 'dxDropDownButton',
options: {
width: '100%',
icon: 'indent',
displayExpr: 'text',
keyExpr: 'lineHeight',
useSelectMode: true,
items: lineHeights,
selectedItemKey: 1.35,
onSelectionChanged() {
onSelectionChanged('Line Height');
},
},
},
{
locateInMenu: 'auto',
location: 'before',
widget: 'dxSelectBox',
options: {
placeholder: 'Font',
displayExpr: 'text',
dataSource: fontFamilies,
inputAttr: { 'aria-label': 'Font' },
onItemClick() {
onFontFamilyClick();
},
},
},
toolbarSeparator,
{
location: 'before',
widget: 'dxButtonGroup',
options: {
displayExpr: 'text',
items: fontStyles,
keyExpr: 'icon',
stylingMode: 'outlined',
selectionMode: 'multiple',
onItemClick(e) {
onButtonClick(e.itemData.hint);
},
},
},
{
location: 'before',
template(itemData, itemIndex, element) {
$(element).addClass('toolbar-separator');
},
},
{
locateInMenu: 'auto',
location: 'before',
widget: 'dxButtonGroup',
template(itemData, itemIndex, element) {
const $buttonGroup = $('<div>').dxButtonGroup({
items: textAlignItems,
keyExpr: 'alignment',
stylingMode: 'outlined',
selectedItemKeys: ['left'],
onItemClick(e) {
onButtonClick(e.itemData.hint);
},
});
$buttonGroup.appendTo(element);
},
menuItemTemplate(itemData, itemIndex, element) {
const $buttonGroup = $('<div>').dxButtonGroup({
displayExpr: 'text',
items: textAlignItemsExtended,
keyExpr: 'alignment',
stylingMode: 'outlined',
selectedItemKeys: ['left'],
onItemClick(e) {
onButtonClick(e.itemData.hint);
},
});
$buttonGroup.appendTo(element);
},
},
{
location: 'before',
widget: 'dxButtonGroup',
options: {
items: listTypes,
keyExpr: 'alignment',
stylingMode: 'outlined',
onItemClick(e) {
onButtonClick(e.itemData.hint);
},
},
},
toolbarSeparator,
{
locateInMenu: 'auto',
location: 'before',
widget: 'dxSelectBox',
options: {
displayExpr: 'text',
valueExpr: 'text',
value: headings[0].text,
dataSource: headings,
inputAttr: { 'aria-label': 'Text Style' },
onItemClick() {
onHeadingClick();
},
},
},
toolbarSeparator,
{
location: 'before',
locateInMenu: 'auto',
widget: 'dxButton',
showText: 'inMenu',
options: {
icon: 'link',
text: 'Link',
onClick() {
onButtonClick('Link');
},
},
},
{
location: 'before',
locateInMenu: 'auto',
widget: 'dxButton',
showText: 'inMenu',
options: {
icon: 'image',
text: 'Add image',
onClick() {
onButtonClick('Add Image');
},
},
},
toolbarSeparator,
{
location: 'before',
locateInMenu: 'auto',
widget: 'dxButton',
showText: 'inMenu',
options: {
icon: 'clearformat',
text: 'Clear formating',
onClick() {
onButtonClick('Clear Formating');
},
},
},
{
location: 'before',
locateInMenu: 'auto',
widget: 'dxButton',
showText: 'inMenu',
options: {
icon: 'codeblock',
text: 'Code block',
onClick() {
onButtonClick('Code Block');
},
},
},
{
location: 'before',
locateInMenu: 'auto',
widget: 'dxButton',
showText: 'inMenu',
options: {
icon: 'blockquote',
text: 'Blockquote',
onClick() {
onButtonClick('Blockquote');
},
},
},
toolbarSeparator,
{
location: 'after',
widget: 'dxButton',
showText: 'inMenu',
options: {
icon: 'attach',
text: 'Attach',
onClick() {
onButtonClick('Attach');
},
},
},
{
locateInMenu: 'always',
widget: 'dxButton',
showText: 'inMenu',
options: {
icon: 'help',
text: 'About',
onClick() {
onButtonClick('About');
},
},
},
];
$(() => {
$('#resizable-container').dxResizable({
minWidth: 500,
minHeight: 150,
maxHeight: 370,
handles: 'right',
area: '.widget-container',
});
const toolbar = $('#toolbar').dxToolbar({
dataSource: toolbarItems,
multiline: true,
}).dxToolbar('instance');
$('#toolbar-mode').dxCheckBox({
value: true,
text: 'Multiline mode',
onValueChanged(e) {
toolbar.option('multiline', e.value);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="widget-container">
<div id="resizable-container" class="resizable-container">
<div id="toolbar"></div>
</div>
</div>
<div class="options-container">
<div class="caption">Options</div>
<div id="toolbar-mode"></div>
</div>
</div>
</body>
</html>
.dx-resizable-handle::after {
content: "";
position: absolute;
width: 9px;
height: 36px;
border: none;
border-radius: 50px;
background-color: #fff;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.24);
}
.dx-resizable-handle-right::after {
top: 50%;
right: -5px;
transform: translateY(-50%);
}
.dx-toolbar.dx-toolbar-multiline .dx-toolbar-item {
margin-bottom: 5px;
}
.widget-container {
margin-right: 10px;
}
.resizable-container {
padding: 10px;
height: 300px;
border: 1px dotted #999;
border-radius: 4px;
box-sizing: border-box;
}
.options-container {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
margin-bottom: 10px;
}
.toolbar-separator {
height: 36px;
margin: 0 5px;
border-left: 1px solid #ddd;
}
.toolbar-menu-separator {
height: 1px;
border-bottom: 1px solid #ddd;
}
const fontSizes = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
const lineHeights = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
const fontFamilies = [
{ text: 'Arial' },
{ text: 'Courier New' },
{ text: 'Georgia' },
{ text: 'Impact' },
{ text: 'Lucida Console' },
{ text: 'Tahoma' },
{ text: 'Times New Roman' },
];
const headings = [
{ text: 'Normal text' },
{ text: 'Heading 1' },
{ text: 'Heading 2' },
{ text: 'Heading 3' },
{ text: 'Heading 4' },
{ text: 'Heading 5' },
];
const fontStyles = [
{
icon: 'bold',
hint: 'Bold',
},
{
icon: 'italic',
hint: 'Italic',
},
{
icon: 'underline',
hint: 'Underlined',
},
{
icon: 'strike',
hint: 'Strikethrough',
},
];
const textAlignItemsExtended = [
{
icon: 'alignleft',
alignment: 'left',
hint: 'Align Left',
text: 'Align left',
},
{
icon: 'aligncenter',
alignment: 'center',
hint: 'Center',
text: 'Center',
},
{
icon: 'alignright',
alignment: 'right',
hint: 'Align Right',
text: 'Align right',
},
{
icon: 'alignjustify',
alignment: 'justify',
hint: 'Justify',
text: 'Justify',
},
];
const textAlignItems = textAlignItemsExtended.map((item) => {
const { icon, alignment, hint } = item;
return {
icon,
alignment,
hint,
};
});
const listTypes = [
{
icon: 'orderedlist',
alignment: 'orderedlist',
hint: 'Ordered',
},
{
icon: 'bulletlist',
alignment: 'bulletlist',
hint: 'Bullet',
},
];

import React, { useCallback, useState } from 'react';
import Toolbar, { Item } from 'devextreme-react/toolbar';
import Button from 'devextreme-react/button';
import ButtonGroup from 'devextreme-react/button-group';
import type { ButtonGroupTypes } from 'devextreme-react/button-group';
import Resizable from 'devextreme-react/resizable';
import CheckBox from 'devextreme-react/check-box';
import type { CheckBoxTypes } from 'devextreme-react/check-box';
import DropDownButton from 'devextreme-react/drop-down-button';
import type { DropDownButtonTypes } from 'devextreme-react/drop-down-button';
import SelectBox from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import themes from 'devextreme/ui/themes';
import notify from 'devextreme/ui/notify';
import 'devextreme/ui/select_box';
import {
fontSizes,
lineHeights,
fontFamilies,
fontStyles,
headings,
textAlignItems,
textAlignItemsExtended,
listTypes,
fontInputAttr,
textStyleInputAttr,
} from './data.ts';
const stylingMode = !themes.current().startsWith('generic') ? 'text' : undefined;
const lineHeightDefault = lineHeights[1].lineHeight;
const textAlignDefault = [textAlignItems[0].alignment];
const fontSizeDefault = fontSizes[2].size;
const headingDefault = headings[0].text;
function onButtonClick(name: string): void {
notify(`The "${name}" button has been clicked`);
}
function onSelectionChanged(name: string): void {
notify(`The "${name}" value has been changed`);
}
function App() {
const [lineHeight, setLineHeight] = useState<number>(lineHeightDefault);
const [textAlign, setTextAlign] = useState<string[]>(textAlignDefault);
const [fontSize, setFontSize] = useState<number>(fontSizeDefault);
const [heading, setHeading] = useState<string>(headingDefault);
const [multiline, setMultiline] = useState<boolean>(true);
const onFontFamilyClick = useCallback(() => {
notify('The "Font Family" value has been changed');
}, []);
const onUndoButtonClick = useCallback(() => {
onButtonClick('Undo');
}, []);
const onButtonGroupClick = useCallback((e: ButtonGroupTypes.ItemClickEvent): void => {
onButtonClick(e.itemData.hint);
}, []);
const onRedoButtonClick = useCallback(() => {
onButtonClick('Redo');
}, []);
const onLinkButtonClick = useCallback(() => {
onButtonClick('Link');
}, []);
const onAddImageButtonClick = useCallback(() => {
onButtonClick('Add Image');
}, []);
const onClearButtonClick = useCallback(() => {
onButtonClick('Clear Formating');
}, []);
const onCodeBlockButtonClick = useCallback(() => {
onButtonClick('Code Block');
}, []);
const onQuoteButtonClick = useCallback(() => {
onButtonClick('Blockquote');
}, []);
const onAttachButtonClick = useCallback(() => {
onButtonClick('Attach');
}, []);
const onAboutButtonClick = useCallback(() => {
onButtonClick('Attach');
}, []);
const onHeadingClick = useCallback(
(e: SelectBoxTypes.ItemClickEvent): void => {
setHeading(e.itemData.text);
notify('The "Heading" value has been changed');
},
[setHeading],
);
const onLineHeightChanged = useCallback(
(e: DropDownButtonTypes.SelectionChangedEvent): void => {
setLineHeight(e.item.lineHeight);
onSelectionChanged('Line Height');
},
[setLineHeight],
);
const onFontSizeChange = useCallback(
(e: DropDownButtonTypes.SelectionChangedEvent): void => {
setFontSize(e.item.size);
onSelectionChanged('Font Size');
},
[setFontSize],
);
const onTextAlignChanged = useCallback(
(e: ButtonGroupTypes.ItemClickEvent): void => {
const { alignment, hint } = e.itemData;
setTextAlign([alignment]);
onButtonClick(hint);
},
[setTextAlign],
);
const onToolbarLineModeChanged = useCallback(
({ value }: CheckBoxTypes.ValueChangedEvent): void => {
setMultiline(value);
},
[setMultiline],
);
const renderFontSize = useCallback(
(itemData) => (
<div style={{ fontSize: `${itemData.size}px` }}>{itemData.text}</div>
),
[],
);
const renderTextAlign = useCallback(
() => (
<ButtonGroup
keyExpr="alignment"
stylingMode="outlined"
items={textAlignItems}
selectedItemKeys={textAlign}
onItemClick={onTextAlignChanged}
></ButtonGroup>
),
[textAlign, onTextAlignChanged],
);
const renderTextAlignMenu = useCallback(
() => (
<ButtonGroup
keyExpr="alignment"
stylingMode="outlined"
items={textAlignItemsExtended}
selectedItemKeys={textAlign}
onItemClick={onTextAlignChanged}
></ButtonGroup>
),
[textAlign, onTextAlignChanged],
);
const renderMenuSeparator = useCallback(
() => <div className="toolbar-menu-separator"></div>,
[],
);
return (
<>
<div className="widget-container">
<Resizable
className="resizable-container"
minWidth={500}
minHeight={150}
maxHeight={370}
handles="right"
area=".widget-container"
>
<Toolbar multiline={multiline}>
<Item location="before">
<Button
icon="undo"
stylingMode={stylingMode}
onClick={onUndoButtonClick}
></Button>
</Item>
<Item location="before">
<Button
icon="redo"
stylingMode={stylingMode}
onClick={onRedoButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item location="before" locateInMenu="auto">
<DropDownButton
width="100%"
displayExpr="text"
keyExpr="size"
useSelectMode={true}
stylingMode={stylingMode}
items={fontSizes}
selectedItemKey={fontSize}
itemRender={renderFontSize}
onSelectionChanged={onFontSizeChange}
></DropDownButton>
</Item>
<Item location="before" locateInMenu="auto">
<DropDownButton
width="100%"
icon="indent"
displayExpr="text"
keyExpr="lineHeight"
useSelectMode={true}
stylingMode={stylingMode}
items={lineHeights}
selectedItemKey={lineHeight}
onSelectionChanged={onLineHeightChanged}
></DropDownButton>
</Item>
<Item location="before" locateInMenu="auto">
<SelectBox
placeholder="Font"
displayExpr="text"
inputAttr={fontInputAttr}
dataSource={fontFamilies}
onItemClick={onFontFamilyClick}
></SelectBox>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item location="before">
<ButtonGroup
keyExpr="icon"
stylingMode="outlined"
selectionMode="multiple"
items={fontStyles}
onItemClick={onButtonGroupClick}
></ButtonGroup>
</Item>
<Item location="before">
<div className="toolbar-separator"></div>
</Item>
<Item
widget="dxButtonGroup"
location="before"
locateInMenu="auto"
render={renderTextAlign}
menuItemRender={renderTextAlignMenu}
></Item>
<Item location="before">
<ButtonGroup
keyExpr="alignment"
stylingMode="outlined"
items={listTypes}
onItemClick={onButtonGroupClick}
></ButtonGroup>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item location="before" locateInMenu="auto">
<SelectBox
displayExpr="text"
valueExpr="text"
inputAttr={textStyleInputAttr}
dataSource={headings}
defaultValue={heading}
onItemClick={onHeadingClick}
></SelectBox>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="link"
text="Link"
stylingMode={stylingMode}
onClick={onLinkButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="image"
text="Add image"
stylingMode={stylingMode}
onClick={onAddImageButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="clearformat"
text="Clear formating"
stylingMode={stylingMode}
onClick={onClearButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="codeblock"
text="Code block"
stylingMode={stylingMode}
onClick={onCodeBlockButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="blockquote"
text="Blockquote"
stylingMode={stylingMode}
onClick={onQuoteButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item location="after" showText="inMenu" widget="dxButton">
<Button
icon="attach"
text="Attach"
stylingMode={stylingMode}
onClick={onAttachButtonClick}
></Button>
</Item>
<Item locateInMenu="always" showText="inMenu" widget="dxButton">
<Button
icon="help"
text="About"
stylingMode={stylingMode}
onClick={onAboutButtonClick}
></Button>
</Item>
</Toolbar>
</Resizable>
</div>
<div className="options-container">
<div className="caption">Options</div>
<CheckBox
text="Multiline mode"
value={multiline}
onValueChanged={onToolbarLineModeChanged}
/>
</div>
</>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import Toolbar, { Item } from 'devextreme-react/toolbar';
import Button from 'devextreme-react/button';
import ButtonGroup from 'devextreme-react/button-group';
import Resizable from 'devextreme-react/resizable';
import CheckBox from 'devextreme-react/check-box';
import DropDownButton from 'devextreme-react/drop-down-button';
import SelectBox from 'devextreme-react/select-box';
import themes from 'devextreme/ui/themes';
import notify from 'devextreme/ui/notify';
import 'devextreme/ui/select_box';
import {
fontSizes,
lineHeights,
fontFamilies,
fontStyles,
headings,
textAlignItems,
textAlignItemsExtended,
listTypes,
fontInputAttr,
textStyleInputAttr,
} from './data.js';
const stylingMode = !themes.current().startsWith('generic') ? 'text' : undefined;
const lineHeightDefault = lineHeights[1].lineHeight;
const textAlignDefault = [textAlignItems[0].alignment];
const fontSizeDefault = fontSizes[2].size;
const headingDefault = headings[0].text;
function onButtonClick(name) {
notify(`The "${name}" button has been clicked`);
}
function onSelectionChanged(name) {
notify(`The "${name}" value has been changed`);
}
function App() {
const [lineHeight, setLineHeight] = useState(lineHeightDefault);
const [textAlign, setTextAlign] = useState(textAlignDefault);
const [fontSize, setFontSize] = useState(fontSizeDefault);
const [heading, setHeading] = useState(headingDefault);
const [multiline, setMultiline] = useState(true);
const onFontFamilyClick = useCallback(() => {
notify('The "Font Family" value has been changed');
}, []);
const onUndoButtonClick = useCallback(() => {
onButtonClick('Undo');
}, []);
const onButtonGroupClick = useCallback((e) => {
onButtonClick(e.itemData.hint);
}, []);
const onRedoButtonClick = useCallback(() => {
onButtonClick('Redo');
}, []);
const onLinkButtonClick = useCallback(() => {
onButtonClick('Link');
}, []);
const onAddImageButtonClick = useCallback(() => {
onButtonClick('Add Image');
}, []);
const onClearButtonClick = useCallback(() => {
onButtonClick('Clear Formating');
}, []);
const onCodeBlockButtonClick = useCallback(() => {
onButtonClick('Code Block');
}, []);
const onQuoteButtonClick = useCallback(() => {
onButtonClick('Blockquote');
}, []);
const onAttachButtonClick = useCallback(() => {
onButtonClick('Attach');
}, []);
const onAboutButtonClick = useCallback(() => {
onButtonClick('Attach');
}, []);
const onHeadingClick = useCallback(
(e) => {
setHeading(e.itemData.text);
notify('The "Heading" value has been changed');
},
[setHeading],
);
const onLineHeightChanged = useCallback(
(e) => {
setLineHeight(e.item.lineHeight);
onSelectionChanged('Line Height');
},
[setLineHeight],
);
const onFontSizeChange = useCallback(
(e) => {
setFontSize(e.item.size);
onSelectionChanged('Font Size');
},
[setFontSize],
);
const onTextAlignChanged = useCallback(
(e) => {
const { alignment, hint } = e.itemData;
setTextAlign([alignment]);
onButtonClick(hint);
},
[setTextAlign],
);
const onToolbarLineModeChanged = useCallback(
({ value }) => {
setMultiline(value);
},
[setMultiline],
);
const renderFontSize = useCallback(
(itemData) => <div style={{ fontSize: `${itemData.size}px` }}>{itemData.text}</div>,
[],
);
const renderTextAlign = useCallback(
() => (
<ButtonGroup
keyExpr="alignment"
stylingMode="outlined"
items={textAlignItems}
selectedItemKeys={textAlign}
onItemClick={onTextAlignChanged}
></ButtonGroup>
),
[textAlign, onTextAlignChanged],
);
const renderTextAlignMenu = useCallback(
() => (
<ButtonGroup
keyExpr="alignment"
stylingMode="outlined"
items={textAlignItemsExtended}
selectedItemKeys={textAlign}
onItemClick={onTextAlignChanged}
></ButtonGroup>
),
[textAlign, onTextAlignChanged],
);
const renderMenuSeparator = useCallback(() => <div className="toolbar-menu-separator"></div>, []);
return (
<>
<div className="widget-container">
<Resizable
className="resizable-container"
minWidth={500}
minHeight={150}
maxHeight={370}
handles="right"
area=".widget-container"
>
<Toolbar multiline={multiline}>
<Item location="before">
<Button
icon="undo"
stylingMode={stylingMode}
onClick={onUndoButtonClick}
></Button>
</Item>
<Item location="before">
<Button
icon="redo"
stylingMode={stylingMode}
onClick={onRedoButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item
location="before"
locateInMenu="auto"
>
<DropDownButton
width="100%"
displayExpr="text"
keyExpr="size"
useSelectMode={true}
stylingMode={stylingMode}
items={fontSizes}
selectedItemKey={fontSize}
itemRender={renderFontSize}
onSelectionChanged={onFontSizeChange}
></DropDownButton>
</Item>
<Item
location="before"
locateInMenu="auto"
>
<DropDownButton
width="100%"
icon="indent"
displayExpr="text"
keyExpr="lineHeight"
useSelectMode={true}
stylingMode={stylingMode}
items={lineHeights}
selectedItemKey={lineHeight}
onSelectionChanged={onLineHeightChanged}
></DropDownButton>
</Item>
<Item
location="before"
locateInMenu="auto"
>
<SelectBox
placeholder="Font"
displayExpr="text"
inputAttr={fontInputAttr}
dataSource={fontFamilies}
onItemClick={onFontFamilyClick}
></SelectBox>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item location="before">
<ButtonGroup
keyExpr="icon"
stylingMode="outlined"
selectionMode="multiple"
items={fontStyles}
onItemClick={onButtonGroupClick}
></ButtonGroup>
</Item>
<Item location="before">
<div className="toolbar-separator"></div>
</Item>
<Item
widget="dxButtonGroup"
location="before"
locateInMenu="auto"
render={renderTextAlign}
menuItemRender={renderTextAlignMenu}
></Item>
<Item location="before">
<ButtonGroup
keyExpr="alignment"
stylingMode="outlined"
items={listTypes}
onItemClick={onButtonGroupClick}
></ButtonGroup>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item
location="before"
locateInMenu="auto"
>
<SelectBox
displayExpr="text"
valueExpr="text"
inputAttr={textStyleInputAttr}
dataSource={headings}
defaultValue={heading}
onItemClick={onHeadingClick}
></SelectBox>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="link"
text="Link"
stylingMode={stylingMode}
onClick={onLinkButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="image"
text="Add image"
stylingMode={stylingMode}
onClick={onAddImageButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="clearformat"
text="Clear formating"
stylingMode={stylingMode}
onClick={onClearButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="codeblock"
text="Code block"
stylingMode={stylingMode}
onClick={onCodeBlockButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
>
<Button
icon="blockquote"
text="Blockquote"
stylingMode={stylingMode}
onClick={onQuoteButtonClick}
></Button>
</Item>
<Item
location="before"
locateInMenu="auto"
menuItemRender={renderMenuSeparator}
>
<div className="toolbar-separator"></div>
</Item>
<Item
location="after"
showText="inMenu"
widget="dxButton"
>
<Button
icon="attach"
text="Attach"
stylingMode={stylingMode}
onClick={onAttachButtonClick}
></Button>
</Item>
<Item
locateInMenu="always"
showText="inMenu"
widget="dxButton"
>
<Button
icon="help"
text="About"
stylingMode={stylingMode}
onClick={onAboutButtonClick}
></Button>
</Item>
</Toolbar>
</Resizable>
</div>
<div className="options-container">
<div className="caption">Options</div>
<CheckBox
text="Multiline mode"
value={multiline}
onValueChanged={onToolbarLineModeChanged}
/>
</div>
</>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type {
FontSize,
LineHeight,
FontFamily,
Heading,
FontStyle,
TextAlignItem,
ListType,
} from './types.ts';
export const fontSizes: FontSize[] = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
export const lineHeights: LineHeight[] = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
export const fontFamilies: FontFamily[] = [
{ text: 'Arial' },
{ text: 'Courier New' },
{ text: 'Georgia' },
{ text: 'Impact' },
{ text: 'Lucida Console' },
{ text: 'Tahoma' },
{ text: 'Times New Roman' },
];
export const headings: Heading[] = [
{ text: 'Normal text' },
{ text: 'Heading 1' },
{ text: 'Heading 2' },
{ text: 'Heading 3' },
{ text: 'Heading 4' },
{ text: 'Heading 5' },
];
export const fontStyles: FontStyle[] = [
{
icon: 'bold',
hint: 'Bold',
},
{
icon: 'italic',
hint: 'Italic',
},
{
icon: 'underline',
hint: 'Underlined',
},
{
icon: 'strike',
hint: 'Strikethrough',
},
];
export const textAlignItemsExtended: TextAlignItem[] = [
{
icon: 'alignleft',
alignment: 'left',
hint: 'Align Left',
text: 'Align left',
},
{
icon: 'aligncenter',
alignment: 'center',
hint: 'Center',
text: 'Center',
},
{
icon: 'alignright',
alignment: 'right',
hint: 'Align Right',
text: 'Align right',
},
{
icon: 'alignjustify',
alignment: 'justify',
hint: 'Justify',
text: 'Justify',
},
];
export const textAlignItems: TextAlignItem[] = textAlignItemsExtended.map((item: TextAlignItem): TextAlignItem => {
const { icon, alignment, hint } = item;
return {
icon,
alignment,
hint,
};
});
export const listTypes: ListType[] = [
{
icon: 'orderedlist',
alignment: 'orderedlist',
hint: 'Ordered',
},
{
icon: 'bulletlist',
alignment: 'bulletlist',
hint: 'Bullet',
},
];
export const fontInputAttr = { 'aria-label': 'Font' };
export const textStyleInputAttr = { 'aria-label': 'Text Style' };
export type FontSize = {
size: number;
text: string;
};
export type LineHeight = {
lineHeight: number;
text: string;
};
export type FontFamily = {
text: string;
};
export type Heading = {
text: string;
};
export type FontStyle = {
icon: string;
hint: string;
};
export type TextAlignItem = {
icon: string;
alignment: string;
hint: string;
text?: string;
};
export type ListType = {
icon: string;
alignment: string;
hint: string;
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const fontSizes = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
export const lineHeights = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
export const fontFamilies = [
{ text: 'Arial' },
{ text: 'Courier New' },
{ text: 'Georgia' },
{ text: 'Impact' },
{ text: 'Lucida Console' },
{ text: 'Tahoma' },
{ text: 'Times New Roman' },
];
export const headings = [
{ text: 'Normal text' },
{ text: 'Heading 1' },
{ text: 'Heading 2' },
{ text: 'Heading 3' },
{ text: 'Heading 4' },
{ text: 'Heading 5' },
];
export const fontStyles = [
{
icon: 'bold',
hint: 'Bold',
},
{
icon: 'italic',
hint: 'Italic',
},
{
icon: 'underline',
hint: 'Underlined',
},
{
icon: 'strike',
hint: 'Strikethrough',
},
];
export const textAlignItemsExtended = [
{
icon: 'alignleft',
alignment: 'left',
hint: 'Align Left',
text: 'Align left',
},
{
icon: 'aligncenter',
alignment: 'center',
hint: 'Center',
text: 'Center',
},
{
icon: 'alignright',
alignment: 'right',
hint: 'Align Right',
text: 'Align right',
},
{
icon: 'alignjustify',
alignment: 'justify',
hint: 'Justify',
text: 'Justify',
},
];
export const textAlignItems = textAlignItemsExtended.map((item) => {
const { icon, alignment, hint } = item;
return {
icon,
alignment,
hint,
};
});
export const listTypes = [
{
icon: 'orderedlist',
alignment: 'orderedlist',
hint: 'Ordered',
},
{
icon: 'bulletlist',
alignment: 'bulletlist',
hint: 'Bullet',
},
];
export const fontInputAttr = { 'aria-label': 'Font' };
export const textStyleInputAttr = { 'aria-label': 'Text Style' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-resizable-handle::after {
content: "";
position: absolute;
width: 9px;
height: 36px;
border: none;
border-radius: 50px;
background-color: #fff;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.24);
}
.dx-resizable-handle-right::after {
top: 50%;
right: -5px;
transform: translateY(-50%);
}
.dx-toolbar.dx-toolbar-multiline .dx-toolbar-item {
margin-bottom: 5px;
}
.widget-container {
margin-right: 10px;
}
.resizable-container {
padding: 10px;
height: 300px;
border: 1px dotted #999;
border-radius: 4px;
box-sizing: border-box;
}
.options-container {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
margin-bottom: 10px;
}
.toolbar-separator {
height: 36px;
margin: 0 5px;
border-left: 1px solid #ddd;
}
.toolbar-menu-separator {
height: 1px;
border-bottom: 1px solid #ddd;
}

<div class="widget-container">
<dx-resizable
class="resizable-container"
[minWidth]="500"
[minHeight]="150"
[maxHeight]="370"
handles="right"
area=".widget-container"
>
<dx-toolbar #toolbar [multiline]="true">
<dxi-toolbar-item location="before" widget="dxButton">
<div *dxTemplate>
<dx-button
icon="undo"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('Undo')"
></dx-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item location="before" widget="dxButton">
<div *dxTemplate>
<dx-button
icon="redo"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('Redo')"
></dx-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
menuItemTemplate="menuSeparatorTemplate"
>
<div *dxTemplate>
<div class="toolbar-separator"></div>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxDropDownButton"
>
<div *dxTemplate>
<dx-drop-down-button
width="100%"
displayExpr="text"
keyExpr="size"
itemTemplate="fontSizeTemplate"
[stylingMode]="stylingMode"
[items]="fontSizes"
[selectedItemKey]="fontSizes[2].size"
[useSelectMode]="true"
(onSelectionChanged)="onSelectionChanged('Font Size')"
>
<div *dxTemplate="let data of 'fontSizeTemplate'">
<div [style.fontSize]="data.size + 'px'">{{ data.text }}</div>
</div>
</dx-drop-down-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxDropDownButton"
>
<div *dxTemplate>
<dx-drop-down-button
width="100%"
icon="indent"
displayExpr="text"
keyExpr="lineHeight"
[stylingMode]="stylingMode"
[items]="lineHeights"
[useSelectMode]="true"
[selectedItemKey]="lineHeight"
(onSelectionChanged)="onSelectionChanged('Line Height')"
></dx-drop-down-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxSelectBox"
>
<div *dxTemplate>
<dx-select-box
placeholder="Font"
displayExpr="text"
[inputAttr]="{ 'aria-label': 'Font' }"
[items]="fontFamilies"
(onItemClick)="onFontFamilyClick()"
></dx-select-box>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
menuItemTemplate="menuSeparatorTemplate"
>
<div *dxTemplate>
<div class="toolbar-separator"></div>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item location="before" widget="dxButtonGroup">
<div *dxTemplate>
<dx-button-group
displayExpr="text"
keyExpr="icon"
stylingMode="outlined"
selectionMode="multiple"
[items]="fontStyles"
(onItemClick)="onButtonClick($event.itemData.hint)"
></dx-button-group>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item location="before">
<div *dxTemplate>
<div class="toolbar-separator"></div>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
widget="dxButtonGroup"
location="before"
locateInMenu="auto"
menuItemTemplate="menuTextAlignTemplate"
>
<div *dxTemplate>
<dx-button-group
keyExpr="alignment"
stylingMode="outlined"
[items]="textAlignItems"
[(selectedItemKeys)]="selectedTextAlign"
(onItemClick)="onTextAlignChanged($event)"
></dx-button-group>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item location="before" widget="dxButtonGroup">
<div *dxTemplate>
<dx-button-group
keyExpr="alignment"
stylingMode="outlined"
[items]="listTypes"
(onItemClick)="onButtonClick($event.itemData.hint)"
></dx-button-group>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
menuItemTemplate="menuSeparatorTemplate"
>
<div *dxTemplate>
<div class="toolbar-separator"></div>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxSelectBox"
>
<div *dxTemplate>
<dx-select-box
displayExpr="text"
valueExpr="text"
[inputAttr]="{ 'aria-label': 'Text Style' }"
[value]="heading"
[items]="headings"
(onItemClick)="onHeadingClick()"
></dx-select-box>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
menuItemTemplate="menuSeparatorTemplate"
>
<div *dxTemplate>
<div class="toolbar-separator"></div>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxButton"
showText="inMenu"
>
<div *dxTemplate>
<dx-button
icon="link"
text="Link"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('Link')"
></dx-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxButton"
showText="inMenu"
>
<div *dxTemplate>
<dx-button
icon="image"
text="Add image"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('Add Image')"
></dx-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
menuItemTemplate="menuSeparatorTemplate"
>
<div *dxTemplate>
<div class="toolbar-separator"></div>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxButton"
showText="inMenu"
>
<div *dxTemplate>
<dx-button
icon="clearformat"
text="Clear formating"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('Clear Formating')"
></dx-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxButton"
showText="inMenu"
>
<div *dxTemplate>
<dx-button
icon="codeblock"
text="Code block"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('Code Block')"
></dx-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
widget="dxButton"
showText="inMenu"
>
<div *dxTemplate>
<dx-button
icon="blockquote"
text="Blockquote"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('Blockquote')"
></dx-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
locateInMenu="auto"
menuItemTemplate="menuSeparatorTemplate"
>
<div *dxTemplate>
<div class="toolbar-separator"></div>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item location="after" widget="dxButton" showText="inMenu">
<div *dxTemplate>
<dx-button
icon="attach"
text="Attach"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('Attach')"
></dx-button>
</div>
</dxi-toolbar-item>
<dxi-toolbar-item
locateInMenu="always"
widget="dxButton"
showText="inMenu"
>
<div *dxTemplate>
<dx-button
icon="help"
text="About"
[stylingMode]="stylingMode"
(onClick)="onButtonClick('About')"
></dx-button>
</div>
</dxi-toolbar-item>
<div *dxTemplate="let data of 'menuSeparatorTemplate'">
<div class="toolbar-menu-separator"></div>
</div>
<div *dxTemplate="let data of 'menuTextAlignTemplate'">
<dx-button-group
keyExpr="alignment"
stylingMode="outlined"
[items]="textAlignItemsExtended"
[selectedItemKeys]="selectedTextAlign"
(onItemClick)="onTextAlignChanged($event)"
></dx-button-group>
</div>
</dx-toolbar>
</dx-resizable>
</div>
<div class="options-container">
<div class="caption">Options</div>
<dx-check-box
[(value)]="toolbar.multiline"
text="Multiline mode"
></dx-check-box>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, inject, provideZoneChangeDetection } from '@angular/core';
import {
DxToolbarModule,
DxSelectBoxModule,
DxResizableModule,
DxDropDownButtonModule,
DxButtonModule,
DxButtonGroupModule,
DxCheckBoxModule,
} from 'devextreme-angular';
import themes from 'devextreme/ui/themes';
import notify from 'devextreme/ui/notify';
import {
FontFamily,
FontSize,
FontStyle,
Heading,
LineHeight,
ListType,
Service,
TextAlign,
TextAlignExtended,
} from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxToolbarModule,
DxSelectBoxModule,
DxResizableModule,
DxDropDownButtonModule,
DxButtonModule,
DxButtonGroupModule,
DxCheckBoxModule,
],
})
export class AppComponent {
customService = inject(Service);
stylingMode = !themes.current().startsWith('generic') ? 'text' : undefined;
fontSizes: FontSize[] = this.customService.getFontSizes();
lineHeights: LineHeight[] = this.customService.getLineHeights();
lineHeight: number[] = [this.lineHeights[1].lineHeight];
fontFamilies: FontFamily[] = this.customService.getFontFamilies();
headings: Heading[] = this.customService.getHeadings();
heading = this.headings[0]?.text;
fontStyles: FontStyle[] = this.customService.getFontStyles();
textAlignItems: TextAlign[] = this.customService.getTextAlign();
textAlignItemsExtended: TextAlignExtended[] = this.customService.getTextAlignExtended();
selectedTextAlign = [this.textAlignItems[0]?.alignment];
listTypes: ListType[] = this.customService.getListType();
constructor() {
}
onTextAlignChanged(e: { itemData: { hint: string } }): void {
this.onButtonClick(e.itemData.hint);
}
onButtonClick(name: string) {
notify(`The "${name}" button has been clicked`);
}
onSelectionChanged(name: string) {
notify(`The "${name}" value has been changed`);
}
onFontFamilyClick() {
notify('The "Font Family" value has been changed');
}
onHeadingClick() {
notify('The "Heading" value has been changed');
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
:host {
display: block;
}
::ng-deep .dx-resizable-handle::after {
content: "";
position: absolute;
width: 9px;
height: 36px;
border: none;
border-radius: 50px;
background-color: #fff;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.24);
}
::ng-deep .dx-resizable-handle-right::after {
top: 50%;
right: -5px;
transform: translateY(-50%);
}
::ng-deep .dx-toolbar.dx-toolbar-multiline .dx-toolbar-item {
margin-bottom: 5px;
}
::ng-deep .widget-container {
margin-right: 10px;
}
::ng-deep .resizable-container {
padding: 10px;
height: 300px;
border: 1px dotted #999;
border-radius: 4px;
box-sizing: border-box;
}
.options-container {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
margin-bottom: 10px;
}
::ng-deep .toolbar-separator {
height: 36px;
margin: 0 5px;
border-left: 1px solid #ddd;
}
::ng-deep .toolbar-menu-separator {
height: 1px;
border-bottom: 1px solid #ddd;
}
import { Injectable } from '@angular/core';
export class FontSize {
size: number;
text: string;
}
export class LineHeight {
lineHeight: number;
text: string;
}
export class FontFamily {
text: string;
}
export class Heading {
text: string;
}
export class FontStyle {
icon: string;
hint: string;
}
export class TextAlign {
icon: string;
alignment: string;
hint: string;
}
export class TextAlignExtended extends TextAlign {
text: string;
}
export class ListType {
icon: string;
alignment: string;
hint: string;
}
const fontSizes: FontSize[] = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
const lineHeights: LineHeight[] = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
const fontFamilies: FontFamily[] = [
{ text: 'Arial' },
{ text: 'Courier New' },
{ text: 'Georgia' },
{ text: 'Impact' },
{ text: 'Lucida Console' },
{ text: 'Tahoma' },
{ text: 'Times New Roman' },
];
const headings: Heading[] = [
{ text: 'Normal text' },
{ text: 'Heading 1' },
{ text: 'Heading 2' },
{ text: 'Heading 3' },
{ text: 'Heading 4' },
{ text: 'Heading 5' },
];
const fontStyles: FontStyle[] = [
{
icon: 'bold',
hint: 'Bold',
},
{
icon: 'italic',
hint: 'Italic',
},
{
icon: 'underline',
hint: 'Underlined',
},
{
icon: 'strike',
hint: 'Strikethrough',
},
];
const textAlignsExtended: TextAlignExtended[] = [
{
icon: 'alignleft',
alignment: 'left',
hint: 'Align Left',
text: 'Align left',
},
{
icon: 'aligncenter',
alignment: 'center',
hint: 'Center',
text: 'Center',
},
{
icon: 'alignright',
alignment: 'right',
hint: 'Align Right',
text: 'Align right',
},
{
icon: 'alignjustify',
alignment: 'justify',
hint: 'Justify',
text: 'Justify',
},
];
const listTypes: ListType[] = [
{
icon: 'orderedlist',
alignment: 'orderedlist',
hint: 'Ordered',
},
{
icon: 'bulletlist',
alignment: 'bulletlist',
hint: 'Bullet',
},
];
@Injectable()
export class Service {
getFontSizes(): FontSize[] {
return fontSizes;
}
getLineHeights(): LineHeight[] {
return lineHeights;
}
getFontFamilies(): FontFamily[] {
return fontFamilies;
}
getHeadings(): Heading[] {
return headings;
}
getFontStyles(): FontStyle[] {
return fontStyles;
}
getTextAlign(): TextAlign[] {
return textAlignsExtended.map(
({ icon, alignment, hint }) => ({ icon, alignment, hint }),
);
}
getTextAlignExtended(): TextAlignExtended[] {
return textAlignsExtended;
}
getListType(): ListType[] {
return listTypes;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<div class="widget-container">
<DxResizable
class="resizable-container"
area=".widget-container"
handles="right"
:min-width="500"
:min-height="150"
:max-height="370"
>
<DxToolbar :multiline="multiline">
<DxItem
location="before"
widget="dxButton"
>
<DxButton
icon="undo"
:styling-mode="stylingMode"
:on-click="onUndoButtonClick"
/>
</DxItem>
<DxItem
location="before"
widget="dxButton"
>
<DxButton
icon="redo"
:styling-mode="stylingMode"
:on-click="onRedoButtonClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
template="separatorTemplate"
menu-item-template="menuSeparatorTemplate"
/>
<DxItem
location="before"
locate-in-menu="auto"
>
<DxDropDownButton
width="100%"
display-expr="text"
key-expr="size"
item-template="fontSizeTemplate"
:styling-mode="stylingMode"
:use-select-mode="true"
:items="fontSizes"
:selected-item-key="fontSize"
:on-selection-changed="onFontSizeSelectionChanged"
>
<template #fontSizeTemplate="{ data }">
<div :style="{ fontSize: data.size + 'px' }">
{{ data.text }}
</div>
</template>
</DxDropDownButton>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
>
<DxDropDownButton
width="100%"
icon="indent"
display-expr="text"
key-expr="lineHeight"
:styling-mode="stylingMode"
:use-select-mode="true"
:items="lineHeights"
:selected-item-key="lineHeight"
:on-selection-changed="onLineHeightSelectionChanged"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
>
<DxSelectBox
placeholder="Font"
display-expr="text"
:input-attr="{ 'aria-label': 'Font' }"
:data-source="fontFamilies"
:on-item-click="onFontFamilyClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
template="separatorTemplate"
menu-item-template="menuSeparatorTemplate"
/>
<DxItem location="before">
<DxButtonGroup
display-expr="text"
key-expr="icon"
styling-mode="outlined"
selection-mode="multiple"
:items="fontStyles"
:on-item-click="onFontStyleItemClick"
/>
</DxItem>
<DxItem
location="before"
template="separatorTemplate"
/>
<DxItem
location="before"
locate-in-menu="auto"
template="textAlignTemplate"
menu-item-template="textAlignMenuTemplate"
widget="dxButtonGroup"
/>
<DxItem location="before">
<DxButtonGroup
key-expr="alignment"
styling-mode="outlined"
:items="listTypes"
:on-item-click="onListTypeButtonClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
template="separatorTemplate"
menu-item-template="menuSeparatorTemplate"
/>
<DxItem
location="before"
locate-in-menu="auto"
>
<DxSelectBox
display-expr="text"
value-expr="text"
:input-attr="{ 'aria-label': 'Text Style' }"
:data-source="headings"
:value="heading"
:on-item-click="onHeadingClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
template="separatorTemplate"
menu-item-template="menuSeparatorTemplate"
/>
<DxItem
location="before"
locate-in-menu="auto"
show-text="inMenu"
widget="dxButton"
>
<DxButton
icon="link"
text="Link"
:styling-mode="stylingMode"
:on-click="onLinkButtonClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
show-text="inMenu"
widget="dxButton"
>
<DxButton
icon="image"
text="Add image"
:styling-mode="stylingMode"
:on-click="onAddImageButtonClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
template="separatorTemplate"
menu-item-template="menuSeparatorTemplate"
/>
<DxItem
location="before"
locate-in-menu="auto"
show-text="inMenu"
widget="dxButton"
>
<DxButton
icon="clearformat"
text="Clear formating"
:styling-mode="stylingMode"
:on-click="onClearButtonClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
show-text="inMenu"
widget="dxButton"
>
<DxButton
icon="codeblock"
text="Code block"
:styling-mode="stylingMode"
:on-click="onCodeBlockButtonClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
show-text="inMenu"
widget="dxButton"
>
<DxButton
icon="blockquote"
text="Blockquote"
:styling-mode="stylingMode"
:on-click="onQuoteButtonClick"
/>
</DxItem>
<DxItem
location="before"
locate-in-menu="auto"
template="separatorTemplate"
menu-item-template="menuSeparatorTemplate"
/>
<DxItem
location="after"
widget="dxButton"
show-text="inMenu"
>
<DxButton
icon="attach"
text="Attach"
:styling-mode="stylingMode"
:on-click="onAttachButtonClick"
/>
</DxItem>
<DxItem
locate-in-menu="always"
widget="dxButton"
show-text="inMenu"
>
<DxButton
icon="help"
text="About"
:styling-mode="stylingMode"
:on-click="onAboutButtonClick"
/>
</DxItem>
<template #separatorTemplate>
<div class="toolbar-separator"/>
</template>
<template #menuSeparatorTemplate>
<div class="toolbar-menu-separator"/>
</template>
<template #textAlignTemplate>
<DxButtonGroup
key-expr="alignment"
styling-mode="outlined"
:items="textAlignItems"
:selected-item-keys="textAlign"
@item-click="onTextAlignItemClick"
/>
</template>
<template #textAlignMenuTemplate>
<DxButtonGroup
:items="textAlignItemsExtended"
display-expr="text"
:selected-item-keys="textAlign"
key-expr="alignment"
styling-mode="outlined"
@item-click="onTextAlignItemClick"
/>
</template>
</DxToolbar>
</DxResizable>
</div>
<div class="options-container">
<div class="caption">Options</div>
<DxCheckBox
v-model="multiline"
text="Multiline mode"
/>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxCheckBox from 'devextreme-vue/check-box';
import DxToolbar, { DxItem } from 'devextreme-vue/toolbar';
import DxButton from 'devextreme-vue/button';
import DxButtonGroup, { type DxButtonGroupTypes } from 'devextreme-vue/button-group';
import DxResizable from 'devextreme-vue/resizable';
import DxDropDownButton from 'devextreme-vue/drop-down-button';
import DxSelectBox from 'devextreme-vue/select-box';
import themes from 'devextreme/ui/themes';
import notify from 'devextreme/ui/notify';
import {
fontSizes,
lineHeights,
fontFamilies,
fontStyles,
headings,
textAlignItems,
textAlignItemsExtended,
listTypes,
} from './data.ts';
import 'devextreme/ui/select_box';
const stylingMode = !themes.current().startsWith('generic') ? 'text' : undefined;
const lineHeightDefault = lineHeights[1].lineHeight;
const textAlignDefault = [textAlignItems[0].alignment];
const fontSizeDefault = fontSizes[2].size;
const headingDefault = headings[0].text;
const multiline = ref(true);
const lineHeight = ref(lineHeightDefault);
const textAlign = ref(textAlignDefault);
const fontSize = ref(fontSizeDefault);
const heading = ref(headingDefault);
function onTextAlignItemClick(e: DxButtonGroupTypes.ItemClickEvent) {
const { alignment, hint } = e.itemData;
textAlign.value = alignment;
onButtonClick(hint);
}
function onButtonClick(name: string) {
notify(`The "${name}" button has been clicked`);
}
function onUndoButtonClick() {
onButtonClick('Undo');
}
function onRedoButtonClick() {
onButtonClick('Redo');
}
function onFontStyleItemClick(e: DxButtonGroupTypes.ItemClickEvent) {
onButtonClick(e.itemData.hint);
}
function onListTypeButtonClick(e: DxButtonGroupTypes.ItemClickEvent) {
onButtonClick(e.itemData.hint);
}
function onLinkButtonClick() {
onButtonClick('Link');
}
function onAddImageButtonClick() {
onButtonClick('Add Image');
}
function onClearButtonClick() {
onButtonClick('Clear Formating');
}
function onCodeBlockButtonClick() {
onButtonClick('Code Block');
}
function onQuoteButtonClick() {
onButtonClick('Blockquote');
}
function onAttachButtonClick() {
onButtonClick('Attach');
}
function onAboutButtonClick() {
onButtonClick('About');
}
function onSelectionChanged(name: string) {
notify(`The "${name}" value has been changed`);
}
function onFontSizeSelectionChanged() {
onSelectionChanged('Font Size');
}
function onLineHeightSelectionChanged() {
onSelectionChanged('Line Height');
}
function onHeadingClick() {
notify('The "Heading" value has been changed');
}
function onFontFamilyClick() {
notify('The "Font Family" value has been changed');
}
</script>
<style>
.dx-resizable-handle::after {
content: "";
position: absolute;
width: 9px;
height: 36px;
border: none;
border-radius: 50px;
background-color: #fff;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.24);
}
.dx-resizable-handle-right::after {
top: 50%;
right: -5px;
transform: translateY(-50%);
}
.dx-toolbar.dx-toolbar-multiline .dx-toolbar-item {
margin-bottom: 5px;
}
.widget-container {
margin-right: 10px;
}
.resizable-container {
padding: 10px;
height: 300px;
border: 1px dotted #999;
border-radius: 4px;
box-sizing: border-box;
}
.options-container {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
margin-bottom: 10px;
}
.toolbar-separator {
height: 36px;
margin: 0 5px;
border-left: 1px solid #ddd;
}
.toolbar-menu-separator {
height: 1px;
border-bottom: 1px solid #ddd;
}
.dx-button-content {
display: flex;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const fontSizes = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
export const lineHeights = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
export const fontFamilies = [
{ text: 'Arial' },
{ text: 'Courier New' },
{ text: 'Georgia' },
{ text: 'Impact' },
{ text: 'Lucida Console' },
{ text: 'Tahoma' },
{ text: 'Times New Roman' },
];
export const headings = [
{ text: 'Normal text' },
{ text: 'Heading 1' },
{ text: 'Heading 2' },
{ text: 'Heading 3' },
{ text: 'Heading 4' },
{ text: 'Heading 5' },
];
export const fontStyles = [
{
icon: 'bold',
hint: 'Bold',
},
{
icon: 'italic',
hint: 'Italic',
},
{
icon: 'underline',
hint: 'Underlined',
},
{
icon: 'strike',
hint: 'Strikethrough',
},
];
export const textAlignItemsExtended = [
{
icon: 'alignleft',
alignment: 'left',
hint: 'Align Left',
text: 'Align left',
},
{
icon: 'aligncenter',
alignment: 'center',
hint: 'Center',
text: 'Center',
},
{
icon: 'alignright',
alignment: 'right',
hint: 'Align Right',
text: 'Align right',
},
{
icon: 'alignjustify',
alignment: 'justify',
hint: 'Justify',
text: 'Justify',
},
];
export const textAlignItems = textAlignItemsExtended.map((item) => {
const { icon, alignment, hint } = item;
return {
icon,
alignment,
hint,
};
});
export const listTypes = [
{
icon: 'orderedlist',
alignment: 'orderedlist',
hint: 'Ordered',
},
{
icon: 'bulletlist',
alignment: 'bulletlist',
hint: 'Bullet',
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>